﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleApplication1
{
    public class FarmEnum : IEnumerator<IFarmRow>
    {
        public IList<IFarmRow> Rows;
        int position = -1;

        public FarmEnum(IList<IFarmRow> rows)
        {
            this.Rows = rows;
        }

        #region IEnumerator<IFarmRow> Members

        public IFarmRow Current
        {
            get
            {
                return Rows[position];
            }
        }

        #endregion

        #region IDisposable Members

        public void Dispose()
        {
        }

        #endregion

        #region IEnumerator Members

        object System.Collections.IEnumerator.Current
        {
            get
            {
                return Rows[position];
            }
        }

        public bool MoveNext()
        {
            if (position + 1 < Rows.Count)
            {
                position += 1;
                return true;
            }
            else
            {
                return false;
            }
        }

        public void Reset()
        {
            position = -1;
        }

        #endregion
    }
}
