﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleApplication1
{
    public class FarmRowEnum : IEnumerator<ICell>
    {
        public IList<ICell> Cells;
        int position = -1;

        public FarmRowEnum(IList<ICell> _Cells)
        {
            this.Cells = _Cells;
        }

        #region IEnumerator<ICell> Members

        public ICell Current
        {
            get
            {
                return Cells[position];
            }
        }

        #endregion

        #region IDisposable Members

        public void Dispose()
        {
        }

        #endregion

        #region IEnumerator Members

        object System.Collections.IEnumerator.Current
        {
            get
            {
                return Cells[position];
            }
        }

        public bool MoveNext()
        {
            if (position + 1 < Cells.Count)
            {
                position += 1;
                return true;
            }
            else
            {
                return false;
            }
        }

        public void Reset()
        {
            position = 0;
        }

        #endregion
    }
}
