﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;

namespace ConsoleApplication1
{
    class Program
    {
        static void Main(string[] args)
        {
            IFarmFactory factory = new FarmFactory();
            IFarm farm0 = factory.CreateFarm(new string[] { "111", "111", "111" });
            IFarm farm1 = factory.CreateFarm(new string[] { "111", "141", "111" });
            IFarm farm2 = factory.CreateFarm(new string[] { "2309", "0239", "2314" });
            IFarm farm3 = factory.CreateFarm(new string[] { "924", "231", "390", "910", "121" });
            IFarm farm4 = factory.CreateFarm(new string[] { "5" });
            IFarm farm5 = factory.CreateFarm(new string[] { "1234567890", "1234567890", "1234567890", "1234567890", "1234567890", "1234567890", "1234567890", "1234567890", "1234567890", "1234567890", "1234567890" });

            System.Diagnostics.Stopwatch watch = new System.Diagnostics.Stopwatch();

            watch.Start();
            for (int i = 0; i < 100000; i++)
            {
                //farm0.GetCellCountSpecialNumBetween(4, 8);
                //farm1.GetCellCountSpecialNumBetween(4, 8);
                //farm2.GetCellCountSpecialNumBetween(5, 7);
                //farm3.GetCellCountSpecialNumBetween(31, 36);
                //farm4.GetCellCountSpecialNumBetween(3, 8);
                farm5.GetCellCountSpecialNumBetween(3, 18);
            }           
            watch.Stop();
            Console.WriteLine("pandora program caculate all spend {0} milliseconds", watch.ElapsedMilliseconds);
            watch.Reset();

            string[] testField = {
                "1234567890",
                 "1234567890",
                 "1234567890",
                 "1234567890",
                 "1234567890",
                 "1234567890",
                 "1234567890",
                 "1234567890",
                 "1234567890",
                 "1234567890",
                 "1234567890"};

            //eaglet 的算法
            Console.WriteLine("eaglet 的算法");
            Console.WriteLine(T1.countSpecialNumbers(new string[] { "111", "111", "111" }, 4, 8));
            Console.WriteLine(T1.countSpecialNumbers(new string[] { "111", "141", "111" }, 4, 8));
            Console.WriteLine(T1.countSpecialNumbers(new string[] { "2309", "0239", "2314" }, 5, 7));
            Console.WriteLine(T1.countSpecialNumbers(new string[] { "924", "231", "390", "910", "121" }, 31, 36));
            Console.WriteLine(T1.countSpecialNumbers(new string[] { "5" }, 3, 8));
            Console.WriteLine(T1.countSpecialNumbers(testField, 3, 18));


            watch.Start();
            for (int i = 0; i < 100000; i++)
            {
                T1.countSpecialNumbers(testField, 3, 18);
            }

            watch.Stop();

            Console.WriteLine("用时" + watch.ElapsedMilliseconds.ToString() + "毫秒");
        }
    }
}
