﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleApplication1
{
    public class Cell : ICell
    {
        private int sn = 0;

        public Cell(int redishNum)
        {
            this.RelatedCells = new List<ICell>();
            this.RedishNum = redishNum;
        }

        #region ICell Members

        public int RedishNum
        {
            get;
            set;
        }

        public int SpecialNumber
        {
            get
            {
                return sn;
            }
        }

        public void SpecialNumberUpdate()
        {
            sn = 0;
            foreach (ICell _cell in this.RelatedCells)
            {
                sn += _cell.RedishNum;
            }
        }

        public IList<ICell> RelatedCells
        {
            get;
            set;
        }

        #endregion
    }
}
