﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleApplication1
{
    public class T1
    {
        /**/
        /// <summary>
        /// 获取第i,j格的特殊程度
        /// </summary>
        /// <param name="field"></param>
        /// <param name="i"></param>
        /// <param name="j"></param>
        /// <returns></returns>
        /// <author>eaglet</author>
        static private int GetSpecialNumbers(string[] field, int width, int i, int j)
        {
            int y = i - 1 >= 0 ? i - 1 : 0;
            int sum = 0;

            while (y <= i + 1 && y < field.Length)
            {
                int x = j - 1 >= 0 ? j - 1 : 0;

                while (x <= j + 1 && x < width)
                {
                    if (x != j || y != i)
                    {
                        sum += field[y][x] - '0';
                    }

                    x++;
                }

                y++;
            }

            return sum;
        }

        /**/
        /// <summary>
        /// 
        /// </summary>
        /// <param name="field"></param>
        /// <param name="A"></param>
        /// <param name="B"></param>
        /// <returns></returns>
        /// <author>eaglet</author>
        static public int countSpecialNumbers(string[] field, int A, int B)
        {
            //Check paramaters
            if (field == null)
            {
                return 0;
            }

            if (field.Length == 0)
            {
                return 0;
            }

            int width = field[0].Length;

            if (width == 0)
            {
                return 0;
            }

            if (A > B)
            {
                throw new ArgumentException("A > B");
            }

            //Begin calculate
            int count = 0;

            for (int i = 0; i < field.Length; i++)
            {
                for (int j = 0; j < field[i].Length; j++)
                {
                    int number = GetSpecialNumbers(field, width, i, j);

                    if (number >= A && number <= B)
                    {
                        count++;
                    }
                }
            }

            return count;
        }
    }

}
